#jinja2:trim_blocks:False
# {{ ansible_managed }}

user nginx;
worker_processes auto;
pid /var/run/nginx.pid;

### DEFAULT LOGS
error_log /var/log/nginx/error.log error;

include /etc/nginx/modules.d/*.conf;

### MONITORING
events {
    worker_connections 1024;
}

http {
    include /etc/nginx/mime.types;
    default_type application/octet-stream;
    sendfile on;
    tcp_nopush on;
    tcp_nodelay on;
    keepalive_timeout 65;
    types_hash_max_size 2048;
    server_names_hash_bucket_size 512;

    resolver {{ dns_resolvers | join(' ') }} valid=300s ipv6=off;
    resolver_timeout 5s;

    ### HARDENING
    # Disable server informations
    server_tokens off;

    # HSTS Strict-Transport-Security
    #add_header Strict-Transport-Security "max-age=31536000; includeSubdomains; preload";

    # Requests client limitation
    client_body_buffer_size 16k;
    client_header_buffer_size 1k;
    client_max_body_size 20m;
    large_client_header_buffers 4 8k;

    ### SSL
    ssl_protocols TLSv1.2;
    ssl_prefer_server_ciphers on;

    ### LOGS
    # https://docs.splunk.com/Documentation/AddOns/released/NGINX/Setupv2 + snet fields
    log_format main 'site="$server_name" server="$host" dest_port="$server_port" dest_ip="$server_addr" '
                    'src="$remote_addr" src_ip="$realip_remote_addr" user="$remote_user" '
                    'time_local="$time_local" protocol="$server_protocol" status="$status" '
                    'bytes_out="$bytes_sent" bytes_in="$upstream_bytes_received" '
                    'http_referer="$http_referer" http_user_agent="$http_user_agent" '
                    'nginx_version="$nginx_version" http_x_forwarded_for="$http_x_forwarded_for" '
                    'http_x_header="$http_x_header" uri_query="$query_string" uri_resolved="$uri" '
                    'http_method="$request_method" response_time="$upstream_response_time" '
                    'cookie="$http_cookie" request_time="$request_time" '
                    'request="$request" http_content_type="$content_type" '
                    'http_authuser="$http_authuser" bytes_body_out="$body_bytes_sent" '
                    'ssl_protocol="$ssl_protocol" ssl_cipher="$ssl_cipher" '
                    'category="-" gzip_ratio="$gzip_ratio" cached="$upstream_cache_status" '
                    'request_length="$request_length" client_port="$remote_port" '
                    'number_of_requests="$connection_requests" uri_path="$request_uri" '
                    'scheme="$scheme" url="$scheme://$host$request_uri" '
                    'upstream_status="$upstream_status" '
                    'rps_backend="{{ inventory_hostname }}" ';

    access_log /var/log/nginx/access.log main;
    error_log /var/log/nginx/error.log error;

    ### COMPRESSION
    gzip on;
    gzip_disable "msie6";

    include /etc/nginx/conf.d/*.conf;
}
